# coding: utf-8

"""
    ColiVara

    Colivara is a suite of services that allows you to store, search, and retrieve documents based on their visual embeddings.      It is a web-first implementation of the ColPali paper using ColQwen2 as backend model. It works exacly like RAG from the end-user standpoint - but using vision models instead of chunking and text-processing for documents.

    The version of the OpenAPI document: 1.0.0
    Contact: founders@colivara.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from colivara_py.models.query_filter import QueryFilter
from typing import Optional, Set
from typing_extensions import Self

class QueryIn(BaseModel):
    """
    QueryIn
    """ # noqa: E501
    query: StrictStr
    collection_name: Optional[StrictStr] = None
    top_k: Optional[StrictInt] = None
    query_filter: Optional[QueryFilter] = None
    __properties: ClassVar[List[str]] = ["query", "collection_name", "top_k", "query_filter"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of QueryIn from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of query_filter
        if self.query_filter:
            _dict['query_filter'] = self.query_filter.to_dict()
        # set to None if collection_name (nullable) is None
        # and model_fields_set contains the field
        if self.collection_name is None and "collection_name" in self.model_fields_set:
            _dict['collection_name'] = None

        # set to None if top_k (nullable) is None
        # and model_fields_set contains the field
        if self.top_k is None and "top_k" in self.model_fields_set:
            _dict['top_k'] = None

        # set to None if query_filter (nullable) is None
        # and model_fields_set contains the field
        if self.query_filter is None and "query_filter" in self.model_fields_set:
            _dict['query_filter'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of QueryIn from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "query": obj.get("query"),
            "collection_name": obj.get("collection_name"),
            "top_k": obj.get("top_k"),
            "query_filter": QueryFilter.from_dict(obj["query_filter"]) if obj.get("query_filter") is not None else None
        })
        return _obj


